%define _unpackaged_files_terminate_build  1
%define _missing_doc_files_terminate_build 1

%define xercesc_dir xerces-c-src_2_7_0

Name: xqilla
Summary: XQilla is an XQuery and XPath 2.0 library, built on top of Xerces-C
Group: System Environment/Libraries
Version: 2.0.0
Release: 1.1%{?dist}
License: ASL 2.0
URL: http://xqilla.sourceforge.net/HomePage
# Original upstream source:
# Source0: http://downloads.sourceforge.net/xqilla/XQilla-%{version}.tar.gz
# 
# Original tarball with src/mapm/mapm_mt.cpp removed (licensing problems)
Source0: XQilla-%{version}.tar.gz
Source1: http://archive.apache.org/dist/xml/xerces-c/Xerces-C_2_7_0/source/xerces-c-src_2_7_0.tar.gz
# mapm_mt.c is wrapper for mapm library to be used in multithreaded apps.
# It was taken from MAPM library ver. 4.9.5 and modified to work with
# XQilla ver. 2.0.0. It's purpose is to replace the removed mapm_mt.cpp.
Source2: mapm_mt.c
Requires: libstdc++ >= 4.1.1 xerces-c >= 2.7.0

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-build
BuildRequires: xerces-c-devel >= 2.7.0 
BuildRequires: autoconf automake libtool
BuildRequires: doxygen graphviz

Patch0: xqilla-xercesc-libdir.patch

%define xercesc_build_root %{_builddir}/%{xercesc_dir}

%description
XQilla is an XQuery and XPath 2.0 implementation written in C++ and based
on Xerces-C. It implements the DOM 3 XPath API, as well as having it's own
more powerful API. It conforms to the W3C proposed recomendation of XQuery
and XPath 2.0.

%package devel
Group: Development/Libraries
Summary: XQilla is an XQuery and XPath 2.0 library, built on top of Xerces-C
Requires: %{name} = %{version}-%{release} xerces-c-devel = 2.7.0

%description devel
XQilla is an XQuery and XPath 2.0 implementation written in C++ and based
on Xerces-C. It implements the DOM 3 XPath API, as well as having it's own
more powerful API. It conforms to the W3C proposed recomendation of XQuery
and XPath 2.0.

%package doc
Group: Documentation
Summary: XQilla documentation

%description doc
simple-api and dom3-api documentation for XQilla.

%prep
%setup -q -b 1 -n XQilla-2.0.0
cp -p %{SOURCE2} src/mapm
ln -s mapm_mt.c src/mapm/mapm_mt.cpp
%patch0

%build
rm -f aclocal.m4
aclocal
libtoolize --force --copy
automake --add-missing --copy --force
autoconf
%configure \
	--disable-static \
	--disable-rpath \
	--with-xerces=%{xercesc_build_root}
sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool
make %{?_smp_mflags}
make docs

%install
rm -rf %{buildroot}
export CPPROG="cp -p"
make install DESTDIR=%{buildroot}
find %{buildroot} -name '*.la' -exec rm -f '{}' ';'
mkdir -p %{buildroot}%{_defaultdocdir}/%{name}-%{version}
cp -pr ChangeLog LICENSE %{buildroot}%{_defaultdocdir}/%{name}-%{version}
cp -pr docs/dom3-api docs/simple-api \
	%{buildroot}%{_defaultdocdir}/%{name}-%{version}
for file in `find %{buildroot}%{_defaultdocdir}/%{name}-%{version}`; do\
	if ! [ -s "$file" ]; then rm -f "$file"; fi;
done

%clean
rm -rf %{buildroot}

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root,-)
%{_bindir}/xqilla
%{_libdir}/libxqilla.so.*
%dir %{_defaultdocdir}/%{name}-%{version}
%{_defaultdocdir}/%{name}-%{version}/ChangeLog
%{_defaultdocdir}/%{name}-%{version}/LICENSE

%files devel
%defattr(-,root,root,-)
%{_libdir}/libxqilla.so
%{_includedir}/xqilla

%files doc
%{_defaultdocdir}/%{name}-%{version}/dom3-api
%{_defaultdocdir}/%{name}-%{version}/simple-api

%changelog
* Thu Feb 28 2008 Milan Zazrivec <mzazrivec@redhat.com> 2.0.0-1.1
- Create xqilla-doc package for xqilla documentation

* Thu Jan 10 2008 Milan Zazrivec <mzazrivec@redhat.com> 2.0.0-1
- Removed src/mapm/mapm_mt.cpp
- Added modified mapm_mt.c, taken from MAPM library ver. 4.9.5
- Added parallel make

* Tue Jan 08 2008 Milan Zazrivec <mzazrivec@redhat.com> 2.0.0-0
- Initial packaging of version 2.0.0
